SUBROUTINE bcucof(y,y1,y2,y12,d1,d2,c)
! Given arrays y, y1, y2, and y12, each of length 4, containing the function, gradients, and
! cross derivative at the four grid points of a rectangular grid cell (numbered counterclockwise
! from the lower left), and given d1 and d2, the length of the grid cell in the 1- and 2-
! directions, this routine returns the 4×4 table c that is used for bicubic interpolation

implicit none
! INPUT VARIABLES
real d1, d2, c(4,4), y(4), y1(4), y12(4), y2(4)
! LOCAL VARIABLES
real wt(16,16), x(16)
data wt /1,0,-3,2,4*0,-3,0,9,-6,2,0,-6,4,&
8*0,3,0,-9,6,-2,0,6,-4,10*0,9,-6,2*0,-6,4,2*0,3,-2,6*0,-9,6,&
2*0,6,-4,4*0,1,0,-3,2,-2,0,6,-4,1,0,-3,2,8*0,-1,0,3,-2,1,0,-3,&
2,10*0,-3,2,2*0,3,-2,6*0,3,-2,2*0,-6,4,2*0,3,-2,0,1,-2,1,5*0,&
-3,6,-3,0,2,-4,2,9*0,3,-6,3,0,-2,4,-2,10*0,-3,3,2*0,2,-2,2*0,&
-1,1,6*0,3,-3,2*0,-2,2,5*0,1,-2,1,0,-2,4,-2,0,1,-2,1,9*0,-1,2,&
-1,0,1,-2,1,10*0,1,-1,2*0,-1,1,6*0,-1,1,2*0,2,-2,2*0,-1,1/

! ** Pack a temporary vector x
x(1:4) = y
x(5:8) = y1*d1
x(9:12) = y2*d2
x(13:16) = y12*d1*d2
! ** Matrix multiply by the stored table
x = matmul(wt,x)
! ** Unpack the result into the output table
c = reshape(x,(/4,4/),order=(/2,1/))

END SUBROUTINE bcucof
