real FUNCTION dsplint(xg,yg,y2g,n,h,x)
! spline interpolation: first derivative interpolated value
! xg(1)<...<xg(n)     => grid points
! yg(1),...,yg(n)     => tabulated function at the grid points
! y2g(1),...,y2g(n)   => second derivatives of the interpolating function at the grid points
! h                   => grid size
! x                   => position in CV space

implicit none
! INPUT VARIABLES
integer n
real h, xg(n), yg(n), y2g(n), x
! LOCAL VARIABLES
integer ig
real ih, a, b

ih = 1.0/h
ig = int(x*ih) + 1
a = (xg(ig+1)-x)*ih
b = 1.0 - a
dsplint = (yg(ig+1)-yg(ig))*ih + h*((3*b**2-1.0)*y2g(ig+1)-(3*a**2-1.0)*y2g(ig))/6.0

END FUNCTION dsplint
