real FUNCTION fesval3(x,y,z)
! B-spline of FES at(x,y) point in the 2D CV
use ftsmod

implicit none
! INPUT VARIABLES
real x, y, z
! LOCAL VARIABLES
integer ix, iy, iz, nxmax, nymax, nzmax, nx, ny, nz, ipx, ipy, ipz
real xl, yl, zl, vab1, vab2
real mx, my, mz, m2

fesval3 = 0.0
! CV coordinates in the local grid system
xl = x - xg(1,1)
yl = y - xg(1,2)
zl = z - xg(1,3)
nxmax = ng(1)
nymax = ng(2)
nzmax = ng(3)
! integer counter for CV coordinates
ix = nint(xl*idcel(1)) 
iy = nint(yl*idcel(2))
iz = nint(zl*idcel(3))
if (ix==0) ix = 1
if (iy==0) iy = 1
if (iz==0) iz = 1
if (ix==(nxmax-1)) ix = nxmax - 2
if (iy==(nymax-1)) iy = nymax - 2
if (iz==(nzmax-1)) iz = nzmax - 2
! distribution by 27 adjacent grid points
do nx = ix-1, ix+1
  ipx = nx*nymax*nxmax
  vab1 = 1.5 + (nx*dcel(1)-xl)*idcel(1)
  vab2 = vab1 - 1.0
  mx = 0.5*(vab1*m2(vab1)+(3.0-vab1)*m2(vab2))
  do ny = iy-1, iy+1
    ipy = ny*nzmax + ipx
    vab1 = 1.5 + (ny*dcel(2)-yl)*idcel(2)
    vab2 = vab1 - 1.0
    my = 0.5*(vab1*m2(vab1)+(3.0-vab1)*m2(vab2))
    do nz = iz-1, iz+1
      ipz = nz + ipy + 1
      vab1 = 1.5 + (nz*dcel(3)-zl)*idcel(3)
      vab2 = vab1 - 1.0
      mz = 0.5*(vab1*m2(vab1)+(3.0-vab1)*m2(vab2))
      fesval3 = fesval3 + mx*my*mz*fesg(ipz)
    enddo
  enddo
enddo

END FUNCTION fesval3
