SUBROUTINE readMm
! Read Metric tensor
use ftsmod
use errormod

implicit none
! local variables
integer i, j, k

! ** Metric tensor:
do i = 1, ncv
  read(uftsm2,*,iostat=k) (Mm(i,j),j=1,ncv)
  if (k>0) call error('readMm', 'Error while reading Metric tensor', faterr)
enddo
! ** Check that metric tensor is symmetric:
do i = 1, ncv-1
  do j = i+1, ncv
    if (Mm(i,j)/=Mm(j,i)) call error ('readMm', 'Metric tensor is not symmetric', faterr)
  enddo
enddo

return
END SUBROUTINE readMm
