SUBROUTINE readgauss
! Read Gaussian hills
use ftsmod
use errormod

implicit none
! local variables
integer i, j, k
real tmp(ncv)

! ** Reading skip lines:
do i = 1, ngskip
 read(ugauss,*,iostat=k)
 if (k>0) call error('readgauss', 'Error while reading Gaussian hills', faterr)
enddo

! ** Reading Gaussian hills parameters:
do i = 1, ngauss
  read(ugauss,*,iostat=k) (zgauss(j,i),j=1,ncv),(tmp(j),j=1,ncv),wgauss(i)
  if (k>0) call error('readgauss', 'Error while reading Gaussian hills', faterr)
  if (i==1) then
    do j = 1, ncv
      if (tmp(j)<=0.0) call error('readgauss', 'Wrong Gaussian width', faterr) 
      dgauss(j) = tmp(j)
    enddo
  else
    do j = 1, ncv
      if (dgauss(j)/=tmp(j)) call error('readgauss', 'Wrong Gaussian width', faterr)
    enddo
  endif
  if (wgauss(i)<0.0)  call error('readgauss', 'Wrong Gaussian height', faterr)
enddo

do j = 1, ncv
  dgauss(j) = 1.0/dgauss(j)**2
enddo

return
END SUBROUTINE readgauss
