SUBROUTINE readgrid
! Obtention of grid points, size and FES in the CV space
use ftsmod
use stdiomod
use errormod

implicit none
! LOCAL VARIABLES
integer nx, ny, nz, ix, iy, iz, ind, k
real tmp
character com*2048
real, parameter :: tol = 1.0e-6

nx = ng(1)
ny = ng(2)
if (ncv==2) then
  ! ** Obtain grid points and FES
  do iy = 1, ny
    do ix = 1, nx
      ind = (ix-1)*ny + iy
      call getlin(com,ugrid,outu)
      read(com,*,iostat=k) xg(ix,1), xg(iy,2), fesg(ind)
      if (k>0) call error('readgrid', 'Error while reading grid points and FES', faterr)
    enddo
  enddo
  ! ** Obtain grid size
  do ix = 1, nx-1
    tmp = xg(ix+1,1) - xg(ix,1)
    if (tmp<=0.0) call error('readgrid', 'Wrong grid size', faterr)
    if (ix==1) dcel(1) = tmp
    if (abs(tmp-dcel(1))>tol*dcel(1)) call error('readgrid', 'Wrong grid size', faterr)
  enddo
  idcel(1) = 1.0/dcel(1)
  do iy = 1, ny-1
    tmp = xg(iy+1,2) - xg(iy,2)
    if (tmp<=0.0) call error('readgrid', 'Wrong grid size', faterr)
    if (iy==1) dcel(2) = tmp
    if (abs(tmp-dcel(2))>tol*dcel(2)) call error('readgrid', 'Wrong grid size', faterr)
  enddo
  idcel(2) = 1.0/dcel(2)
else ! ncv=3
  nz = ng(3)
  ! ** Obtain grid points and FES
  do iz = 1, nz
    do iy = 1, ny
      do ix = 1, nx
        ind = (ix-1)*ny*nz + (iy-1)*nz + iz
        call getlin(com,ugrid,outu)
        read(com,*,iostat=k) xg(ix,1), xg(iy,2), xg(iz,3), fesg(ind)
        if (k>0) call error('readgrid', 'Error while reading grid points and FES', faterr)
      enddo
    enddo
  enddo
  ! ** Obtain grid size
  do ix = 1, nx-1
    tmp = xg(ix+1,1) - xg(ix,1)
    if (tmp<=0.0) call error('readgrid', 'Wrong grid size', faterr)
    if (ix==1) dcel(1) = tmp
    if (abs(tmp-dcel(1))>tol*dcel(1)) call error('readgrid', 'Wrong grid size', faterr)
  enddo
  idcel(1) = 1.0/dcel(1)
  do iy = 1, ny-1
    tmp = xg(iy+1,2) - xg(iy,2)
    if (tmp<=0.0) call error('readgrid', 'Wrong grid size', faterr)
    if (iy==1) dcel(2) = tmp
    if (abs(tmp-dcel(2))>tol*dcel(2)) call error('readgrid', 'Wrong grid size', faterr)
  enddo
  idcel(2) = 1.0/dcel(2)
  do iz = 1, nz-1
    tmp = xg(iz+1,2) - xg(iz,2)
    if (tmp<=0.0) call error('readgrid', 'Wrong grid size', faterr)
    if (iz==1) dcel(3) = tmp
    if (abs(tmp-dcel(3))>tol*dcel(3)) call error('readgrid', 'Wrong grid size', faterr)
  enddo
  idcel(3) = 1.0/dcel(3)     
endif

END SUBROUTINE readgrid
