SUBROUTINE readiimag(k)
! Read end images for the initial string
use ftsmod
use errormod

implicit none
integer k
! local variables
integer i, j

! ** Angle CVs?:
read(ufts2,*,iostat=j) Qangcv
if (j>0) call error('readiimag', 'Error while reading end images for the initial string', faterr)
if (Qangcv) then
  angcv(:) = .false.
  ! ** Constant module for angle CVs:
  read(ufts2,*,iostat=j) (dcv(i),i=1,ncv)
  if (j>0) call error('readiimag', 'Error while reading end images for the initial string', faterr)
  do i = 1, ncv
    if (dcv(i)>0.0) angcv(i) = .true.
  enddo
endif
! ** End images (ncv dimension):
if (k==1) then ! FTSM order
  read(ufts2,*,iostat=j) (rho(i,1),i=1,ncv)
  if (j>0) call error('readiimag', 'Error while reading end images for the initial string', faterr)
  read(ufts2,*,iostat=j) (rho(i,mig),i=1,ncv)
  if (j>0) call error('readiimag', 'Error while reading end images for the initial string', faterr)
else ! k=2, STRM order
  read(ufts2,*,iostat=j) (zrep(i,1),i=1,ncv)
  if (j>0) call error('readiimag', 'Error while reading end images for the initial string', faterr)
  read(ufts2,*,iostat=j) (zrep(i,mig),i=1,ncv)
  if (j>0) call error('readiimag', 'Error while reading end images for the initial string', faterr)
endif

return
END SUBROUTINE readiimag
