SUBROUTINE readimages(l)
! Read images for the initial string
use ftsmod
use errormod

implicit none
integer l
! local variables
integer i, j, k

! ** Angle CVs?:
read(ufts,*,iostat=k)
if (k>0) call error('readimages', 'Error while reading images for the initial string', faterr)
read(ufts,*,iostat=k) Qangcv
if (k>0) call error('readimages', 'Error while reading images for the initial string', faterr)
if (Qangcv) then
  angcv(:) = .false.
  ! ** Constant module for angle CVs:
  read(ufts,*,iostat=k)
  if (k>0) call error('readimages', 'Error while reading images for the initial string', faterr)
  read(ufts,*,iostat=k) (dcv(j),j=1,ncv)
  if (k>0) call error('readimages', 'Error while reading images for the initial string', faterr)
  do j = 1, ncv
    if (dcv(j)>0.0) angcv(j) = .true.
  enddo 
endif
! ** Images (ncv dimension):
read(ufts,*,iostat=k)
if (k>0) call error('readimages', 'Error while reading images for the initial string', faterr)
if (l==1) then ! FTSM order
  do i = 1, mig
    read(ufts,*,iostat=k) (rho(j,i),j=1,ncv)
    if (k>0) call error('readimages', 'Error while reading images for the initial string', faterr)
  enddo
  ! ** Initial replicas
  do i = 1, mig
    do j = 1, ncv
      zrep(j,i) = rho(j,i)
    enddo
  enddo
else ! l=2, STRM order
  do i = 1, mig
    read(ufts,*,iostat=k) (zrep(j,i),j=1,ncv)
    if (k>0) call error('readimages', 'Error while reading images for the initial string', faterr)
  enddo
endif

return
END SUBROUTINE readimages
