SUBROUTINE readmatrices
! Read matrices file
use ftsmod
use errormod

implicit none
! local variables
integer i, j, k

! ** Metric tensor:
read(uftsm,*,iostat=k)
if (k>0) call error('readmatrices', 'Error while reading Metric tensor', faterr)
do i = 1, ncv
  read(uftsm,*,iostat=k) (Mm(i,j),j=1,ncv)
  if (k>0) call error('readmatrices', 'Error while reading Metric tensor', faterr)
enddo
do i = 1, ncv-1
  do j = i+1, ncv
    if (Mm(i,j)/=Mm(j,i)) call error ('readmatrices', 'Metric tensor is not symmetric', faterr)
  enddo
enddo
! ** Inverse metric tensor:
read(uftsm,*,iostat=k)
if (k>0) call error('readmatrices', 'Error while reading Inverse metric tensor', faterr)
do i = 1, ncv
 read(uftsm,*,iostat=k) (Mminv(i,j),j=1,ncv)
 if (k>0) call error('readmatrices', 'Error while reading Inverse metric tensor', faterr)
enddo
do i = 1, ncv-1
  do j = i+1, ncv
    if (Mminv(i,j)/=Mminv(j,i)) call error ('readmatrices', 'Inverse metric tensor is not symmetric', faterr)
  enddo
enddo
! ** Random tensor:
read(uftsm,*,iostat=k)
if (k>0) call error('readmatrices', 'Error while reading Random tensor', faterr)
do i = 1, ncv
 read(uftsm,*,iostat=k) (sigmat(i,j),j=1,ncv)
 if (k>0) call error('readmatrices', 'Error while reading Random tensor', faterr)
enddo

return
END SUBROUTINE readmatrices
