subroutine rgauss2(vec)
! R. E Odeh and J. O. Evans, "The percentage points of the normal distribution", App. Sat., 23:96-97 (1974)
! A vector of ncv pseudorandom number is generated, each from a standard normal distribution
! (mean zero, variance one)
use ftsmod

implicit none
double precision :: vec(ncv), MRG32k3a
! local variables
integer :: i
double precision :: temp
double precision, parameter :: p0=-0.322232431088d0,p1=-1.0d0,p2=-0.342242088547d0,p3=-0.204231210245d-1,p4=-0.453642210148d-4, &
                               q0=0.99348462606d-1,q1=0.588581570495d0,q2=0.531103462366d0,q3=0.10353775285d0,q4=0.38560700634d-2  
do i = 1,ncv
  vec(i) = MRG32k3a()
  temp = vec(i) 
  if (temp>0.5d0) vec(i) = 1.0d0 - vec(i)
  vec(i) = sqrt(log(1.0d0/(vec(i)*vec(i))))
  vec(i) = vec(i) + ((((vec(i)*p4+p3)*vec(i)+p2)*vec(i)+p1)*vec(i)+p0)/ &
                    ((((vec(i)*q4+q3)*vec(i)+q2)*vec(i)+q1)*vec(i)+q0)
  if (temp<0.5d0) vec(i) = -vec(i)
end do

return
end subroutine
