module rngmod
! Parameters for MRG32k3a Random Generator Number (RGN).
! Before the procedure is call for the first time, one must initialize s10, s11, s12 to (exact) non-negative 
! integers less than m1 and not all zero, and s20, s21, s22 to (exact) non-negative integers less than m2
! and not all zero.

implicit none
double precision, parameter :: norm = 2.328306549295728d-10
double precision, parameter :: m1 = 4294967087.0, m2 = 4294944443.0 ! moduli (distintic primes)
double precision, parameter :: a12 = 1403580.0, a13 = 810728.0, a21 = 527612.0, a23 = 1370589.0 ! coefficients
double precision :: s10, s11, s12, s20, s21, s22 ! seeds 

end module
