program simul
!
!.....simul - main program unit.
!
!
use errormod
use stdiomod
!
!.....Local variables:
!
implicit none
integer           marg, mflg
parameter         (marg = 2, mflg = 1)
character*80      arg(marg)
integer           i,la,nios
logical*1         larg(marg), lflg(mflg), getopt
character*1       null
data (larg(i),i=1,marg) /marg*.false./
data (lflg(i),i=1,mflg) /mflg*.false./

luwrite    = stdout 
!
!.....parse command line
!
if (.not. getopt(arg, larg, marg, 'h', lflg, mflg, null, 0, null)) &
  call error ('simul','run program as: string [input [output]] [-h]', faterr)
!
!.....help:
!
if (lflg(1)) then
   call header (stdout)
   call help (stdout)
   stop 0
endif
!
!.....open input and output files:
!
call ioinit ()
if (larg(1)) then
   call lualloc (inpu)
   la = len_trim(arg(1))
   open (inpu, file = arg(1)(1:la), status = 'old', iostat = nios)
   if (nios .ne. 0) call error ('simul', 'error while opening '//arg(1)(1:la), faterr)
else
   inpu = stdin
endif
if (larg(2)) then
   call lualloc(outu)
   la = len_trim(arg(2))
   open (outu, file = arg(2)(1:la), status='unknown', iostat=nios)
   if (nios .ne. 0) call error ('simul', 'error while opening '//arg(2)(1:la), faterr)
else
   outu = stdout
endif
luwrite = outu
!
!.....read & interpret input file:
!
call shell_simul
!
!.....end of run:
!
if (inpu .ne. stdin) then
   close (inpu)
   call lunalloc (inpu)
endif
if (outu .ne. stdout) then
   close (outu)
   call lunalloc (outu)
endif
end
