SUBROUTINE solve_tridiag(d,x)
! Thomas algorithm for solving tridiagonal systems
use ftsmod

implicit none
! input/output variables
real d(ncv,mig-2), x(ncv,mig-2)
!real, dimension(:,:), intent(inout) ::  d, x 
! local variables
integer i, j
real cte, icte, m, cp(ncv,mig-2), dp(ncv,mig-2)

cte = 1.0 + 2.0*kappt
icte = 1.0/cte
do j = 1, ncv
  ! Solve for vectors cp and dp
  cp(j,1) = -kappt*icte
  dp(j,1) = d(j,1)*icte
  do i = 2, mig-2
    m = 1.0/(cte+cp(j,i-1)*kappt)
    cp(j,i) = -kappt*m
    dp(j,i) = (d(j,i)+dp(j,i-1)*kappt)*m
  enddo
  ! Solve for x from the vectors cp and dp
  x(j,mig-2) = dp(j,mig-2)
  do i = mig-3, 1, -1
    x(j,i) = dp(j,i) - cp(j,i)*x(j,i+1)
  enddo
enddo

return
END SUBROUTINE solve_tridiag
