SUBROUTINE writegrid
! Write FES in the CV space
use ftsmod

implicit none
! LOCAL VARIABLES
integer nx, ny, nz, ix, iy, iz
real dhx, dhy, dhz, x, y, z, fesval2, fesval3
character wrtline*2048

nx = ng2(1)
ny = ng2(2)
dhx = (xg(ng(1),1)-xg(1,1))/(nx-1.0)
dhy = (xg(ng(2),2)-xg(1,2))/(ny-1.0)
if (ncv==2) then
  write(ugrid2,'(a)') '# CV1 --- CV2 --- FES'
  do iy = 2, ny-1
    y = xg(1,2) + (iy-1)*dhy
    do ix = 2, nx-1
      x = xg(1,1) + (ix-1)*dhx
      write(wrtline,*) x,y,fesval2(x,y)
      write(ugrid2,'(a)') trim(adjustl(wrtline))
    enddo
    write(ugrid2,*)
  enddo
else ! ncv=3
  nz = ng2(3)
  dhz = (xg(ng(3),3)-xg(1,3))/(nz-1.0)
  write(ugrid2,'(a)') '# CV1 --- CV2 --- CV3 --- FES'
  do iz = 2, nz-1
    z = xg(1,3) + (iz-1)*dhz
    do iy = 2, ny-1
      y = xg(1,2) + (iy-1)*dhy
      do ix = 2, nx-1
        x = xg(1,1) + (ix-1)*dhx
        write(wrtline,*) x,y,z,fesval3(x,y,z)
        write(ugrid2,'(a)') trim(adjustl(wrtline))
      enddo
      write(ugrid2,*)
    enddo
    write(ugrid2,*)
  enddo
endif

END SUBROUTINE writegrid
